/*********************************************************************************
 *
 * File name:       router_function.h
 * Version:         5.0
 * Software:        CLAP
 * Author:          Luan H.K. Duong (HKUST), Jiang Xu (HKUST)
 * Website:         http://www.ece.ust.hk/~eexu
 *
 * The copyright information of this program can be found in the file COPYRIGHT.
 *
 *********************************************************************************/
#include "router_analyzer.h"
#include <fstream>
#include <iostream>
#include <string>
using namespace std;

#ifndef router_function
#define router_function

class Router_func{
ifstream router_config; //Contains the router configuration defined by the user
Router_Analyzer* router; //We will apply the router configuration on an intanse of optical router
int xtalk_order; //Defines to which order of crosstalk noise the user wants the calculations
double* output_pwrs; //Results of the calculated output powers at different ports
int wdm_num;//number of wavelengths in the case of using WDM

public:	
//	ofstream file_result;//to show the final results
	Router_func();
	~Router_func();
	void set_mrs(); //Used to set the MR statuses of the optical router (More than one MR could be turned on/off)
	void find_path_rtrfunc(int,int,int,double,int,int,int); //Used in calculations for optical routers
	void show_output_pwrs(char,int,ofstream&);
	void optical_router_analyzer(char ch);
};

#endif
