/*********************************************************************************
 *
 * File name:       router_structure.cpp
 * Version:         5.0
 * Software:        CLAP
 * Author:          Luan H.K. Duong (HKUST), Jiang Xu (HKUST)
 * Website:         http://www.ece.ust.hk/~eexu
 *
 * The copyright information of this program can be found in the file COPYRIGHT.
 *
 *********************************************************************************/
#include "router_structure.h"
#include <cstdlib>
#include <string>
using namespace std;

//set up the structure
Router_Struct::Router_Struct()
{
	router_struct.open("Router_Structure_Definition.txt",ios::in);
	if(!router_struct.is_open())
	{
		cout<<"\nThe Router_Structure_Definition.txt file is not open!\n";
		exit(1);
	}
	router_struct.close();
}

Router_Struct::~Router_Struct()
{
	delete [] mr;
	delete [] port;
	delete [] wc;
	delete [] wb;
	delete [] ot;
	delete [] coupler;
	delete [] cse;
	delete [] pse;
	delete [] wgd;
	delete [] elm;
	delete [] port_type;
}
//void Router_Struct::set_up_structure(int input,int output)
//{
//	string* str1=new string[1];
//	string* dummy1=new string[1];
//	int loc,id;
//	//int PRT_count=0,WC_count=0,WB_count=0,OT_count=0,CSE_count=0,PSE_count=0,WGD_count=0;
//	router_struct.open("Router_Structure_Definition.txt",ios::in);
//	if(router_struct.is_open())
//	{
//		//Start reading the number of elements from the input text file
//		while(!router_struct.eof())
//		{
//			getline(router_struct,str1[0]);
//			if((str1[0].length()!=0 && str1[0][0]=='/' && str1[0][1]=='/') || str1[0].length()==0) //Skip the commments and empty lines
//				continue;
//			else if(str1[0]=="MR_config")
//				break;
//			else
//			{
//				//Read the number of elements
//				if(str1[0][0]=='#')
//				{
//					if(str1[0].compare(1,3,"MR=")==0)
//					{
//						dummy1[0].assign(str1[0],4,str1[0].find(';')-4);
//						number_of_MRs=atoi(dummy1[0].c_str());
//						dummy1[0].erase();
//					}
//					else if(str1[0].compare(1,4,"PRT=")==0)
//					{
//						dummy1[0].assign(str1[0],5,str1[0].find(';')-5);
//						number_of_ports=atoi(dummy1[0].c_str());
//						dummy1[0].erase();
//					}
//					else if(str1[0].compare(1,4,"WCR=")==0)
//					{
//						dummy1[0].assign(str1[0],5,str1[0].find(';')-5);
//						number_of_crossings=atoi(dummy1[0].c_str());
//						dummy1[0].erase();
//					}
//					else if(str1[0].compare(1,4,"WBN=")==0)
//					{
//						dummy1[0].assign(str1[0],5,str1[0].find(';')-5);
//						number_of_bendings=atoi(dummy1[0].c_str());
//						dummy1[0].erase();
//					}
//					else if(str1[0].compare(1,4,"OTR=")==0)
//					{
//						dummy1[0].assign(str1[0],5,str1[0].find(';')-5);
//						number_of_terminators=atoi(dummy1[0].c_str());
//						dummy1[0].erase();
//					}
//					else if(str1[0].compare(1,4,"CSE=")==0)
//					{
//						dummy1[0].assign(str1[0],5,str1[0].find(';')-5);
//						number_of_CSEs=atoi(dummy1[0].c_str());
//						dummy1[0].erase();
//					}
//					else if(str1[0].compare(1,4,"PSE=")==0)
//					{
//						dummy1[0].assign(str1[0],5,str1[0].find(';')-5);
//						number_of_PSEs=atoi(dummy1[0].c_str());
//						dummy1[0].erase();
//					}
//					else if(str1[0].compare(1,4,"WGD=")==0)
//					{
//						dummy1[0].assign(str1[0],5,str1[0].find(';')-5);
//						number_of_WGDs=atoi(dummy1[0].c_str());
//						dummy1[0].erase();
//					}
//				}
//			}
//		}
//		total_number=number_of_ports+number_of_crossings+number_of_bendings+number_of_terminators+number_of_CSEs+number_of_PSEs+number_of_WGDs;
//		mr=new MR[number_of_MRs];
//		port=new Port[total_number];
//		wc=new Crossing[total_number];
//		wb=new Bending[total_number];
//		ot=new Terminator[total_number];
//		cse=new CSE[total_number];
//		pse=new PSE[total_number];
//		wgd=new Waveguide[total_number];
//		elm=new Element[total_number];
//		port_type=new int[number_of_ports];
//		//cout<<number_of_MRs<<" "<<number_of_bendings<<" "<<number_of_crossings<<" "<<number_of_ports<<" "<<number_of__CSEs<<" "<<number_of_PSEs<<" "<<number_of_terminators;
//
//		for(int i=0;i<total_number;i++)
//		{
//			//Ports
//			port[i].set_pwr(0);
//
//			//Crossings
//			wc[i].set_w_pwr(0);
//			wc[i].set_n_pwr(0);
//			wc[i].set_e_pwr(0);
//			wc[i].set_s_pwr(0);
//
//			//Bending
//			wb[i].set_in_pwr(0);
//			wb[i].set_out_pwr(0);
//
//			//Terminator
//			ot[i].set_in_pwr(0);
//			ot[i].set_out_pwr(0);
//
//			//CSEs
//			cse[i].set_w_pwr(0);
//			cse[i].set_n_pwr(0);
//			cse[i].set_e_pwr(0);
//			cse[i].set_s_pwr(0);
//
//			//PSEs
//			pse[i].set_in_pwr(0);
//			pse[i].set_ad_pwr(0);
//			pse[i].set_d_pwr(0);
//			pse[i].set_t_pwr(0);
//
//			//Waveguises
//			wgd[i].set_in_pwr(0);
//			wgd[i].set_out_pwr(0);
//		}
//
//		
//		if(input>(number_of_ports-1) || output>(number_of_ports-1))
//		{
//			cout<<"\nERROR: the input/output port number exceeds the number of ports!\n";
//			exit(1);
//		}
//
//		//MR Configuration
//		while(!router_struct.eof())
//		{
//			loc=0;
//			getline(router_struct,str1[0]);
//			if((str1[0].length()!=0 && str1[0][0]=='/' && str1[0][1]=='/') || str1[0].length()==0) //Skip the commments and empty lines
//				continue;
//			else if(str1[0].compare(0,5,"start")==0)
//				break;
//			else if(str1[0].compare(0,2,"if")==0)	
//			{
//				//Read the related input port
//				while(str1[0][str1[0].find("input=")+6+loc]!=';')
//					loc++;
//				dummy1[0].assign(str1[0],str1[0].find("input=")+6,loc);
//				if(input==atoi(dummy1[0].c_str()))
//				{
//					loc=0;
//					dummy1[0].erase();
//					while(str1[0][str1[0].find("output=")+7+loc]!=';')
//						loc++;
//					dummy1[0].assign(str1[0],str1[0].find("output=")+7,loc);
//					if(output==atoi(dummy1[0].c_str()))
//					{
//						loc=0;
//						dummy1[0].erase();
//						while(str1[0][str1[0].find("MR=")+3+loc]!=';')
//							loc++;
//						dummy1[0].assign(str1[0],str1[0].find("MR=")+3,loc);
//						mr[atoi(dummy1[0].c_str())].set_MR_status(1);
//					}
//				}
//			}
//		}
//
//		//Start reading the structure
//		while(!router_struct.eof())
//		{
//			loc=0;
//			getline(router_struct,str1[0]);
//			if((str1[0].length()!=0 && str1[0][0]=='/' && str1[0][1]=='/') || str1[0].length()==0) //Skip the commments and empty lines
//				continue;
//			else if(str1[0]=="end")
//				break;
//			else
//			{
//				if(str1[0].compare(0,6,"define")==0)
//				{
//					if(str1[0].compare(7,3,"PRT")==0) //Port definition
//					{
//						//id
//						while(str1[0][str1[0].find("id=")+3+loc]!=';' )
//							loc++;
//						dummy1[0].assign(str1[0],str1[0].find("id=")+3,loc);
//						id=atoi(dummy1[0].c_str());
//						dummy1[0].erase();
//						elm[id].id=id;
//						elm[id].type=1; //Port type=1
//
//						//prev
//						loc=0;
//						while(str1[0][str1[0].find("prev=")+5+loc]!=';' ) 
//							loc++;
//						dummy1[0].assign(str1[0],str1[0].find("prev=")+5,loc);
//						port[id].set_prev(atoi(dummy1[0].c_str()));
//						dummy1[0].erase();
//						
//						//next
//						loc=0;
//						while(str1[0][str1[0].find("next=")+5+loc]!=';') 
//							loc++;
//						dummy1[0].assign(str1[0],str1[0].find("next=")+5,loc);
//						port[id].set_next(atoi(dummy1[0].c_str()));
//						dummy1[0].erase();
//
//						//port_def
//						loc=0;
//						while(str1[0][str1[0].find("prt_def=")+8+loc]!=';') 
//							loc++;
//						dummy1[0].assign(str1[0],str1[0].find("prt_def=")+8,loc);
//						port_type[atoi(dummy1[0].c_str())]=id;
//						dummy1[0].erase();
//
//						//terminal, for port the terminal[0] is used
//						loc=0;
//						while(str1[0][str1[0].find("con=")+4+loc]!=';') 
//							loc++;
//						dummy1[0].assign(str1[0],str1[0].find("con=")+4,loc);
//						elm[id].terminals[0]=atoi(dummy1[0].c_str());
//						dummy1[0].erase();
//					}
//					else if(str1[0].compare(7,3,"WCR")==0) //Waveguide Crossing Definition
//					{
//						//id
//						while(str1[0][str1[0].find("id=")+3+loc]!=';' )
//							loc++;
//						dummy1[0].assign(str1[0],str1[0].find("id=")+3,loc);
//						id=atoi(dummy1[0].c_str());
//						dummy1[0].erase();
//						elm[id].id=id;
//						elm[id].type=2; //WCR type=2
//
//						//west
//						loc=0;
//						while(str1[0][str1[0].find("west=")+5+loc]!=';' ) 
//							loc++;
//						dummy1[0].assign(str1[0],str1[0].find("west=")+5,loc);
//						wc[id].set_west(atoi(dummy1[0].c_str()));
//						dummy1[0].erase();
//
//						//north
//						loc=0;
//						while(str1[0][str1[0].find("north=")+6+loc]!=';' ) 
//							loc++;
//						dummy1[0].assign(str1[0],str1[0].find("north=")+6,loc);
//						wc[id].set_north(atoi(dummy1[0].c_str()));
//						dummy1[0].erase();
//
//						//east
//						loc=0;
//						while(str1[0][str1[0].find("east=")+5+loc]!=';' ) 
//							loc++;
//						dummy1[0].assign(str1[0],str1[0].find("east=")+5,loc);
//						wc[id].set_east(atoi(dummy1[0].c_str()));
//						dummy1[0].erase();
//
//						//south
//						loc=0;
//						while(str1[0][str1[0].find("south=")+6+loc]!=';' ) 
//							loc++;
//						dummy1[0].assign(str1[0],str1[0].find("south=")+6,loc);
//						wc[id].set_south(atoi(dummy1[0].c_str()));
//						dummy1[0].erase();
//
//						//terminals
//						//west (terminal[1])
//						loc=0;
//						while(str1[0][str1[0].find("con_w=")+6+loc]!=';') 
//							loc++;
//						dummy1[0].assign(str1[0],str1[0].find("con_w=")+6,loc);
//						elm[id].terminals[1]=atoi(dummy1[0].c_str());
//						dummy1[0].erase();
//
//						//north (terminal[2])
//						loc=0;
//						while(str1[0][str1[0].find("con_n=")+6+loc]!=';') 
//							loc++;
//						dummy1[0].assign(str1[0],str1[0].find("con_n=")+6,loc);
//						elm[id].terminals[2]=atoi(dummy1[0].c_str());
//						dummy1[0].erase();
//
//						//east (terminal[3])
//						loc=0;
//						while(str1[0][str1[0].find("con_e=")+6+loc]!=';') 
//							loc++;
//						dummy1[0].assign(str1[0],str1[0].find("con_e=")+6,loc);
//						elm[id].terminals[3]=atoi(dummy1[0].c_str());
//						dummy1[0].erase();
//
//						//south (terminal[4])
//						loc=0;
//						while(str1[0][str1[0].find("con_s=")+6+loc]!=';') 
//							loc++;
//						dummy1[0].assign(str1[0],str1[0].find("con_s=")+6,loc);
//						elm[id].terminals[4]=atoi(dummy1[0].c_str());
//						dummy1[0].erase();
//					}
//					else if(str1[0].compare(7,3,"WBN")==0) //Waveguide Bending Definition
//					{
//						//id
//						while(str1[0][str1[0].find("id=")+3+loc]!=';' )
//							loc++;
//						dummy1[0].assign(str1[0],str1[0].find("id=")+3,loc);
//						id=atoi(dummy1[0].c_str());
//						dummy1[0].erase();
//						elm[id].id=id;
//						elm[id].type=3; //Waveguide Bending type=3
//
//						//in
//						loc=0;
//						while(str1[0][str1[0].find("in=")+3+loc]!=';' ) 
//							loc++;
//						dummy1[0].assign(str1[0],str1[0].find("in=")+3,loc);
//						wb[id].set_in(atoi(dummy1[0].c_str()));
//						dummy1[0].erase();
//
//						//out
//						loc=0;
//						while(str1[0][str1[0].find("out=")+4+loc]!=';' ) 
//							loc++;
//						dummy1[0].assign(str1[0],str1[0].find("out=")+4,loc);
//						wb[id].set_out(atoi(dummy1[0].c_str()));
//						dummy1[0].erase();
//
//						//terminals
//						//in (terminal[1])
//						loc=0;
//						while(str1[0][str1[0].find("con_in=")+7+loc]!=';') 
//							loc++;
//						dummy1[0].assign(str1[0],str1[0].find("con_in=")+7,loc);
//						elm[id].terminals[1]=atoi(dummy1[0].c_str());
//						dummy1[0].erase();
//
//						//out (terminal[2])
//						loc=0;
//						while(str1[0][str1[0].find("con_out=")+8+loc]!=';') 
//							loc++;
//						dummy1[0].assign(str1[0],str1[0].find("con_out=")+8,loc);
//						elm[id].terminals[2]=atoi(dummy1[0].c_str());
//						dummy1[0].erase();
//					}
//					else if(str1[0].compare(7,3,"OTR")==0) //Optical Terminator Definition
//					{
//						//id
//						while(str1[0][str1[0].find("id=")+3+loc]!=';' )
//							loc++;
//						dummy1[0].assign(str1[0],str1[0].find("id=")+3,loc);
//						id=atoi(dummy1[0].c_str());
//						dummy1[0].erase();
//						elm[id].id=id;
//						elm[id].type=4; //Optical Terminator type=4
//
//						//in
//						loc=0;
//						while(str1[0][str1[0].find("in=")+3+loc]!=';' ) 
//							loc++;
//						dummy1[0].assign(str1[0],str1[0].find("in=")+3,loc);
//						ot[id].set_in(atoi(dummy1[0].c_str()));
//						dummy1[0].erase();
//
//						//terminals
//						//in (terminal[1])
//						loc=0;
//						while(str1[0][str1[0].find("con_in=")+7+loc]!=';') 
//							loc++;
//						dummy1[0].assign(str1[0],str1[0].find("con_in=")+7,loc);
//						elm[id].terminals[1]=atoi(dummy1[0].c_str());
//						dummy1[0].erase();
//					}
//					else if(str1[0].compare(7,3,"CSE")==0) //Crossing Switching Element Definition
//					{
//						//id
//						while(str1[0][str1[0].find("id=")+3+loc]!=';' )
//							loc++;
//						dummy1[0].assign(str1[0],str1[0].find("id=")+3,loc);
//						id=atoi(dummy1[0].c_str());
//						dummy1[0].erase();
//						elm[id].id=id;
//						elm[id].type=5; //Crossing Switching Element type=5
//
//						//west
//						loc=0;
//						while(str1[0][str1[0].find("west=")+5+loc]!=';' ) 
//							loc++;
//						dummy1[0].assign(str1[0],str1[0].find("west=")+5,loc);
//						cse[id].set_west(atoi(dummy1[0].c_str()));
//						dummy1[0].erase();
//
//						//north
//						loc=0;
//						while(str1[0][str1[0].find("north=")+6+loc]!=';' ) 
//							loc++;
//						dummy1[0].assign(str1[0],str1[0].find("north=")+6,loc);
//						cse[id].set_north(atoi(dummy1[0].c_str()));
//						dummy1[0].erase();
//
//						//east
//						loc=0;
//						while(str1[0][str1[0].find("east=")+5+loc]!=';' ) 
//							loc++;
//						dummy1[0].assign(str1[0],str1[0].find("east=")+5,loc);
//						cse[id].set_east(atoi(dummy1[0].c_str()));
//						dummy1[0].erase();
//
//						//south
//						loc=0;
//						while(str1[0][str1[0].find("south=")+6+loc]!=';' ) 
//							loc++;
//						dummy1[0].assign(str1[0],str1[0].find("south=")+6,loc);
//						cse[id].set_south(atoi(dummy1[0].c_str()));
//						dummy1[0].erase();
//
//						//MR number
//						loc=0;
//						while(str1[0][str1[0].find("MR=")+3+loc]!=';' ) 
//							loc++;
//						dummy1[0].assign(str1[0],str1[0].find("MR=")+3,loc);
//						cse[id].set_CSE_MR(mr[atoi(dummy1[0].c_str())]);
//						cse[id].set_CSE_MR_num(atoi(dummy1[0].c_str()));
//						dummy1[0].erase();
//
//						//MR Location
//						loc=0;
//						while(str1[0][str1[0].find("MR_L=")+5+loc]!=';' ) 
//							loc++;
//						dummy1[0].assign(str1[0],str1[0].find("MR_L=")+5,loc);
//						cse[id].set_CSE_MR_Loc(atoi(dummy1[0].c_str()));
//						dummy1[0].erase();
//
//						//terminals
//						//west (terminal[1])
//						loc=0;
//						while(str1[0][str1[0].find("con_w=")+6+loc]!=';') 
//							loc++;
//						dummy1[0].assign(str1[0],str1[0].find("con_w=")+6,loc);
//						elm[id].terminals[1]=atoi(dummy1[0].c_str());
//						dummy1[0].erase();
//
//						//north (terminal[2])
//						loc=0;
//						while(str1[0][str1[0].find("con_n=")+6+loc]!=';') 
//							loc++;
//						dummy1[0].assign(str1[0],str1[0].find("con_n=")+6,loc);
//						elm[id].terminals[2]=atoi(dummy1[0].c_str());
//						dummy1[0].erase();
//
//						//east (terminal[3])
//						loc=0;
//						while(str1[0][str1[0].find("con_e=")+6+loc]!=';') 
//							loc++;
//						dummy1[0].assign(str1[0],str1[0].find("con_e=")+6,loc);
//						elm[id].terminals[3]=atoi(dummy1[0].c_str());
//						dummy1[0].erase();
//
//						//south (terminal[4])
//						loc=0;
//						while(str1[0][str1[0].find("con_s=")+6+loc]!=';') 
//							loc++;
//						dummy1[0].assign(str1[0],str1[0].find("con_s=")+6,loc);
//						elm[id].terminals[4]=atoi(dummy1[0].c_str());
//						dummy1[0].erase();
//					}
//					else if(str1[0].compare(7,3,"PSE")==0) //Parallel Switching Element Definition
//					{
//						//id
//						while(str1[0][str1[0].find("id=")+3+loc]!=';' )
//							loc++;
//						dummy1[0].assign(str1[0],str1[0].find("id=")+3,loc);
//						id=atoi(dummy1[0].c_str());
//						dummy1[0].erase();
//						elm[id].id=id;
//						elm[id].type=6; //Parallel Switching Element type=6
//
//						//in
//						loc=0;
//						while(str1[0][str1[0].find("in=")+3+loc]!=';' ) 
//							loc++;
//						dummy1[0].assign(str1[0],str1[0].find("in=")+3,loc);
//						pse[id].set_input(atoi(dummy1[0].c_str()));
//						dummy1[0].erase();
//
//						//drop
//						loc=0;
//						while(str1[0][str1[0].find("drop=")+5+loc]!=';' ) 
//							loc++;
//						dummy1[0].assign(str1[0],str1[0].find("drop=")+5,loc);
//						pse[id].set_drop(atoi(dummy1[0].c_str()));
//						dummy1[0].erase();
//
//						//through
//						loc=0;
//						while(str1[0][str1[0].find("through=")+8+loc]!=';' ) 
//							loc++;
//						dummy1[0].assign(str1[0],str1[0].find("through=")+8,loc);
//						pse[id].set_thorugh(atoi(dummy1[0].c_str()));
//						dummy1[0].erase();
//
//						//add
//						loc=0;
//						while(str1[0][str1[0].find("add=")+4+loc]!=';' ) 
//							loc++;
//						dummy1[0].assign(str1[0],str1[0].find("add=")+4,loc);
//						pse[id].set_add(atoi(dummy1[0].c_str()));
//						dummy1[0].erase();
//
//						//MR number
//						loc=0;
//						while(str1[0][str1[0].find("MR=")+3+loc]!=';' ) 
//							loc++;
//						dummy1[0].assign(str1[0],str1[0].find("MR=")+3,loc);
//						pse[id].set_PSE_MR(mr[atoi(dummy1[0].c_str())]);
//						pse[id].set_PSE_MR_num(atoi(dummy1[0].c_str()));
//						dummy1[0].erase();
//
//						//terminals
//						//input (terminal[1])
//						loc=0;
//						while(str1[0][str1[0].find("con_in=")+7+loc]!=';') 
//							loc++;
//						dummy1[0].assign(str1[0],str1[0].find("con_in=")+7,loc);
//						elm[id].terminals[1]=atoi(dummy1[0].c_str());
//						dummy1[0].erase();
//
//						//drop (terminal[2])
//						loc=0;
//						while(str1[0][str1[0].find("con_d=")+6+loc]!=';') 
//							loc++;
//						dummy1[0].assign(str1[0],str1[0].find("con_d=")+6,loc);
//						elm[id].terminals[2]=atoi(dummy1[0].c_str());
//						dummy1[0].erase();
//
//						//through (terminal[3])
//						loc=0;
//						while(str1[0][str1[0].find("con_t=")+6+loc]!=';') 
//							loc++;
//						dummy1[0].assign(str1[0],str1[0].find("con_t=")+6,loc);
//						elm[id].terminals[3]=atoi(dummy1[0].c_str());
//						dummy1[0].erase();
//
//						//add (terminal[4])
//						loc=0;
//						while(str1[0][str1[0].find("con_a=")+6+loc]!=';') 
//							loc++;
//						dummy1[0].assign(str1[0],str1[0].find("con_a=")+6,loc);
//						elm[id].terminals[4]=atoi(dummy1[0].c_str());
//						dummy1[0].erase();
//					}
//					else if(str1[0].compare(7,3,"WGD")==0) //Extra Waveguides need to construct the router structure
//					{
//						//id
//						while(str1[0][str1[0].find("id=")+3+loc]!=';' )
//							loc++;
//						dummy1[0].assign(str1[0],str1[0].find("id=")+3,loc);
//						id=atoi(dummy1[0].c_str());
//						dummy1[0].erase();
//						elm[id].id=id;
//						elm[id].type=7; //Waveguide type=7
//
//						//in
//						loc=0;
//						while(str1[0][str1[0].find("in=")+3+loc]!=';' ) 
//							loc++;
//						dummy1[0].assign(str1[0],str1[0].find("in=")+3,loc);
//						wgd[id].set_in(atoi(dummy1[0].c_str()));
//						dummy1[0].erase();
//
//						//out
//						loc=0;
//						while(str1[0][str1[0].find("out=")+4+loc]!=';' ) 
//							loc++;
//						dummy1[0].assign(str1[0],str1[0].find("out=")+4,loc);
//						wgd[id].set_out(atoi(dummy1[0].c_str()));
//						dummy1[0].erase();
//
//						//Length
//						loc=0;
//						while(str1[0][str1[0].find("length=")+7+loc]!=';' ) 
//							loc++;
//						dummy1[0].assign(str1[0],str1[0].find("length=")+7,loc);
//						wgd[id].set_length(atof(dummy1[0].c_str()));
//						dummy1[0].erase();
//
//						//terminals
//						//in (terminal[1])
//						loc=0;
//						while(str1[0][str1[0].find("con_in=")+7+loc]!=';') 
//							loc++;
//						dummy1[0].assign(str1[0],str1[0].find("con_in=")+7,loc);
//						elm[id].terminals[1]=atoi(dummy1[0].c_str());
//						dummy1[0].erase();
//
//						//out (terminal[2])
//						loc=0;
//						while(str1[0][str1[0].find("con_out=")+8+loc]!=';') 
//							loc++;
//						dummy1[0].assign(str1[0],str1[0].find("con_out=")+8,loc);
//						elm[id].terminals[2]=atoi(dummy1[0].c_str());
//						dummy1[0].erase();
//					}
//				}
//			}
//		}
//	}
//	router_struct.close();
//	//delete [] str1;
//	//delete [] dummy1;
//	//for(int i=0;i<number_of_ports;i++)
//		//cout<<endl<<port[i].get_prev()<<endl<<port[i].get_next();
//	//cout<<endl;
//	//for(int i=0;i<10;i++)
//		//cout<<"\nID:"<<elm[i].id<<endl<<"Type:"<<elm[i].type<<"\n "<<"Teminal"<<elm[i].terminals[0];
//	
//	//for(int i=0;i<total_number;i++)
//		//cout<<"\nID:"<<elm[i].id<<endl<<"Type: "<<elm[i].type<<"\n "<<"Teminal "<<elm[i].terminals[0]<<" "<<elm[i].terminals[1]<<" "<<elm[i].terminals[2]<<" "<<elm[i].terminals[3]<<" "<<elm[i].terminals[4]<<endl;
//	//for(int i=0;i<number_of_crossings;i++)
//		//cout<<endl<<wc[i].get_west()<<" "<<wc[i].get_north()<<" "<<wc[i].get_east()<<" "<<wc[i].get_south()<<endl;
//	//for(int i=0;i<number_of_bendings;i++)
//		//cout<<endl<<wb[i].get_in()<<endl<<wb[i].get_out();
//	//for(int i=0;i<number_of_CSEs;i++)
//		//cout<<cse[i].get_west()<<" "<<cse[i].get_north()<<" "<<cse[i].get_east()<<" "<<cse[i].get_south()<<" "<<cse[i].get_CSE_MR()<<" "<<cse[i].get_CSE_MR_Loc()<<endl;
//	//for(int i=0;i<number_of_PSEs;i++)
//		//cout<<pse[i].get_id()<<endl<<pse[i].get_input()<<" "<<pse[i].get_drop()<<" "<<pse[i].get_through()<<" "<<pse[i].get_add()<<" "<<pse[i].get_PSE_MR()<<endl;
//	//for(int i=0;i<number_of_WGDs;i++)
//		//cout<<endl<<wgd[i].get_in()<<endl<<wgd[i].get_out();
//	//for(int i=0;i<number_of_ports;i++)
//		//cout<<endl<<port_type[i];
//	
//}


void Router_Struct::set_up_structure(int input,int output)
{
	int loc,id;
	string str,dummy,test;
	//int PRT_count=0,WC_count=0,WB_count=0,OT_count=0,CSE_count=0,PSE_count=0,WGD_count=0;
	router_struct.open("Router_Structure_Definition.txt",ios::in);
	if(router_struct.is_open())
	{
		//Start reading the number of elements from the input text file
		while(!router_struct.eof())
		{
			getline(router_struct,str);
			if((str.length()!=0 && str[0]=='/' && str[1]=='/') || str.length()==0) //Skip the commments and empty lines
				continue;
			else if(str=="MR_config")
				break;
			else
			{
				//Read the tech profile number
				if(str.compare(0,12,"TechProfile=")==0)
				{
					dummy.assign(str,12,str.find(';')-12);
					tech_profile_number=atoi(dummy.c_str());
					//tech_profile_number=dummy;
					dummy.erase();
					//cout << "The router's technology profile number is: " << tech_profile_number << endl;
				}
				else if(str[0]=='#') //Read the number of elements
				{
					if(str.compare(1,3,"MR=")==0)
					{
						dummy.assign(str,4,str.find(';')-4);
						number_of_MRs=atoi(dummy.c_str());
						dummy.erase();
					}
					else if(str.compare(1,4,"PRT=")==0)
					{
						dummy.assign(str,5,str.find(';')-5);
						number_of_ports=atoi(dummy.c_str());
						dummy.erase();
					}
					else if(str.compare(1,4,"WCR=")==0)
					{
						dummy.assign(str,5,str.find(';')-5);
						number_of_crossings=atoi(dummy.c_str());
						dummy.erase();
					}
					else if(str.compare(1,4,"WBN=")==0)
					{
						dummy.assign(str,5,str.find(';')-5);
						number_of_bendings=atoi(dummy.c_str());
						dummy.erase();
					}
					else if(str.compare(1,4,"OTR=")==0)
					{
						dummy.assign(str,5,str.find(';')-5);
						number_of_terminators=atoi(dummy.c_str());
						dummy.erase();
					}
					else if(str.compare(1,4,"OPN=")==0)
					{
						dummy.assign(str,5,str.find(';')-5);
						number_of_optical_pins=atoi(dummy.c_str());
						dummy.erase();
					}
					else if(str.compare(1,4,"CSE=")==0)
					{
						dummy.assign(str,5,str.find(';')-5);
						number_of_CSEs=atoi(dummy.c_str());
						dummy.erase();
					}
					else if(str.compare(1,4,"PSE=")==0)
					{
						dummy.assign(str,5,str.find(';')-5);
						number_of_PSEs=atoi(dummy.c_str());
						dummy.erase();
					}
					else if(str.compare(1,4,"WGD=")==0)
					{
						dummy.assign(str,5,str.find(';')-5);
						number_of_WGDs=atoi(dummy.c_str());
						dummy.erase();
					}
				}
			}
		}
                //cout << tech_profile_number << endl;
		total_number=number_of_ports+number_of_crossings+number_of_bendings+number_of_terminators+number_of_CSEs+number_of_PSEs+number_of_WGDs;
		mr=new MR[number_of_MRs];
		port=new Port[total_number];
		wc=new Crossing[total_number];
		wb=new Bending[total_number];
		ot=new Terminator[total_number];
		coupler=new OPN[total_number];
		cse=new CSE[total_number];
		pse=new PSE[total_number];
		wgd=new Waveguide[total_number];
		elm=new Element[total_number];
		port_type=new int[number_of_ports];
		//cout<<number_of_MRs<<" "<<number_of_bendings<<" "<<number_of_crossings<<" "<<number_of_ports<<" "<<number_of__CSEs<<" "<<number_of_PSEs<<" "<<number_of_terminators;

		for(int i=0;i<total_number;i++)
		{
			//Ports
			port[i].set_pwr(0);

			//Crossings
			wc[i].set_w_pwr(0);
			wc[i].set_n_pwr(0);
			wc[i].set_e_pwr(0);
			wc[i].set_s_pwr(0);

			//Bending
			wb[i].set_in_pwr(0);
			wb[i].set_out_pwr(0);

			//Terminator
			ot[i].set_in_pwr(0);
			ot[i].set_out_pwr(0);
			
			//Optical Pins
			coupler[i].set_in_pwr(0);
			coupler[i].set_out_pwr(0);

			//CSEs
			cse[i].set_w_pwr(0);
			cse[i].set_n_pwr(0);
			cse[i].set_e_pwr(0);
			cse[i].set_s_pwr(0);

			//PSEs
			pse[i].set_in_pwr(0);
			pse[i].set_ad_pwr(0);
			pse[i].set_d_pwr(0);
			pse[i].set_t_pwr(0);

			//Waveguises
			wgd[i].set_in_pwr(0);
			wgd[i].set_out_pwr(0);
		}

		
		if(input>(number_of_ports-1) || output>(number_of_ports-1))
		{
			cout<<"\nERROR: the input/output port number exceeds the number of ports!\n";
			exit(1);
		}

		//MR Configuration
		while(!router_struct.eof())
		{
			loc=0;
			getline(router_struct,str);
			if((str.length()!=0 && str[0]=='/' && str[1]=='/') || str.length()==0) //Skip the commments and empty lines
				continue;
			else if(str.compare(0,5,"start")==0)
				break;
			else if(str.compare(0,2,"if")==0)	
			{
				//Read the related input port
				while(str[str.find("input=")+6+loc]!=';')
					loc++;
				dummy.assign(str,str.find("input=")+6,loc);
				if(input==atoi(dummy.c_str()))
				{
					loc=0;
					dummy.erase();
					while(str[str.find("output=")+7+loc]!=';')
						loc++;
					dummy.assign(str,str.find("output=")+7,loc);
					if(output==atoi(dummy.c_str()))
					{
						loc=0;
						dummy.erase();
						while(str[str.find("MR=")+3+loc]!=';')
							loc++;
						dummy.assign(str,str.find("MR=")+3,loc);
						mr[atoi(dummy.c_str())].set_MR_status(1);
					}
				}
			}
		}

		//Start reading the structure
		while(!router_struct.eof())
		{
			loc=0;
			getline(router_struct,str);
			if((str.length()!=0 && str[0]=='/' && str[1]=='/') || str.length()==0) //Skip the commments and empty lines
				continue;
			else if(str=="end")
				break;
			else
			{
				if(str.compare(0,6,"define")==0)
				{
					if(str.compare(7,3,"PRT")==0) //Port definition
					{
						//id
						while(str[str.find("id=")+3+loc]!=';' )
							loc++;
						dummy.assign(str,str.find("id=")+3,loc);
						id=atoi(dummy.c_str());
						dummy.erase();
						elm[id].id=id;
						elm[id].type=1; //Port type=1

						//prev
						loc=0;
						while(str[str.find("prev=")+5+loc]!=';' ) 
							loc++;
						dummy.assign(str,str.find("prev=")+5,loc);
						port[id].set_prev(atoi(dummy.c_str()));
						dummy.erase();
						
						//next
						loc=0;
						while(str[str.find("next=")+5+loc]!=';') 
							loc++;
						dummy.assign(str,str.find("next=")+5,loc);
						port[id].set_next(atoi(dummy.c_str()));
						dummy.erase();

						//port_def
						loc=0;
						while(str[str.find("prt_def=")+8+loc]!=';') 
							loc++;
						dummy.assign(str,str.find("prt_def=")+8,loc);
						port_type[atoi(dummy.c_str())]=id;
						dummy.erase();

						//terminal, for port the terminal[0] is used
						loc=0;
						while(str[str.find("con=")+4+loc]!=';') 
							loc++;
						dummy.assign(str,str.find("con=")+4,loc);
						elm[id].terminals[0]=atoi(dummy.c_str());
						dummy.erase();
					}
					else if(str.compare(7,3,"WCR")==0) //Waveguide Crossing Definition
					{
						//id
						while(str[str.find("id=")+3+loc]!=';' )
							loc++;
						dummy.assign(str,str.find("id=")+3,loc);
						id=atoi(dummy.c_str());
						dummy.erase();
						elm[id].id=id;
						elm[id].type=2; //WCR type=2

						//west
						loc=0;
						while(str[str.find("west=")+5+loc]!=';' ) 
							loc++;
						dummy.assign(str,str.find("west=")+5,loc);
						wc[id].set_west(atoi(dummy.c_str()));
						dummy.erase();

						//north
						loc=0;
						while(str[str.find("north=")+6+loc]!=';' ) 
							loc++;
						dummy.assign(str,str.find("north=")+6,loc);
						wc[id].set_north(atoi(dummy.c_str()));
						dummy.erase();

						//east
						loc=0;
						while(str[str.find("east=")+5+loc]!=';' ) 
							loc++;
						dummy.assign(str,str.find("east=")+5,loc);
						wc[id].set_east(atoi(dummy.c_str()));
						dummy.erase();

						//south
						loc=0;
						while(str[str.find("south=")+6+loc]!=';' ) 
							loc++;
						dummy.assign(str,str.find("south=")+6,loc);
						wc[id].set_south(atoi(dummy.c_str()));
						dummy.erase();

						//terminals
						//west (terminal[1])
						loc=0;
						while(str[str.find("con_w=")+6+loc]!=';') 
							loc++;
						dummy.assign(str,str.find("con_w=")+6,loc);
						elm[id].terminals[1]=atoi(dummy.c_str());
						dummy.erase();

						//north (terminal[2])
						loc=0;
						while(str[str.find("con_n=")+6+loc]!=';') 
							loc++;
						dummy.assign(str,str.find("con_n=")+6,loc);
						elm[id].terminals[2]=atoi(dummy.c_str());
						dummy.erase();

						//east (terminal[3])
						loc=0;
						while(str[str.find("con_e=")+6+loc]!=';') 
							loc++;
						dummy.assign(str,str.find("con_e=")+6,loc);
						elm[id].terminals[3]=atoi(dummy.c_str());
						dummy.erase();

						//south (terminal[4])
						loc=0;
						while(str[str.find("con_s=")+6+loc]!=';') 
							loc++;
						dummy.assign(str,str.find("con_s=")+6,loc);
						elm[id].terminals[4]=atoi(dummy.c_str());
						dummy.erase();
					}
					else if(str.compare(7,3,"WBN")==0) //Waveguide Bending Definition
					{
						//id
						while(str[str.find("id=")+3+loc]!=';' )
							loc++;
						dummy.assign(str,str.find("id=")+3,loc);
						id=atoi(dummy.c_str());
						dummy.erase();
						elm[id].id=id;
						elm[id].type=3; //Waveguide Bending type=3

						//in
						loc=0;
						while(str[str.find("in=")+3+loc]!=';' ) 
							loc++;
						dummy.assign(str,str.find("in=")+3,loc);
						wb[id].set_in(atoi(dummy.c_str()));
						dummy.erase();

						//out
						loc=0;
						while(str[str.find("out=")+4+loc]!=';' ) 
							loc++;
						dummy.assign(str,str.find("out=")+4,loc);
						wb[id].set_out(atoi(dummy.c_str()));
						dummy.erase();

						//terminals
						//in (terminal[1])
						loc=0;
						while(str[str.find("con_in=")+7+loc]!=';') 
							loc++;
						dummy.assign(str,str.find("con_in=")+7,loc);
						elm[id].terminals[1]=atoi(dummy.c_str());
						dummy.erase();

						//out (terminal[2])
						loc=0;
						while(str[str.find("con_out=")+8+loc]!=';') 
							loc++;
						dummy.assign(str,str.find("con_out=")+8,loc);
						elm[id].terminals[2]=atoi(dummy.c_str());
						dummy.erase();
					}
					else if(str.compare(7,3,"OTR")==0) //Optical Terminator Definition
					{
						//id
						while(str[str.find("id=")+3+loc]!=';' )
							loc++;
						dummy.assign(str,str.find("id=")+3,loc);
						id=atoi(dummy.c_str());
						dummy.erase();
						elm[id].id=id;
						elm[id].type=4; //Optical Terminator type=4

						//in
						loc=0;
						while(str[str.find("in=")+3+loc]!=';' ) 
							loc++;
						dummy.assign(str,str.find("in=")+3,loc);
						ot[id].set_in(atoi(dummy.c_str()));
						dummy.erase();

						//terminals
						//in (terminal[1])
						loc=0;
						while(str[str.find("con_in=")+7+loc]!=';') 
							loc++;
						dummy.assign(str,str.find("con_in=")+7,loc);
						elm[id].terminals[1]=atoi(dummy.c_str());
						dummy.erase();
					}
					else if(str.compare(7,3,"OPN")==0) //Optical Pins
					{
						//id
						while(str[str.find("id=")+3+loc]!=';' )
							loc++;
						dummy.assign(str,str.find("id=")+3,loc);
						id=atoi(dummy.c_str());
						dummy.erase();
						elm[id].id=id;
						elm[id].type=11; //Optical Pins type=11

						//in
						loc=0;
						while(str[str.find("in=")+3+loc]!=';' ) 
							loc++;
						dummy.assign(str,str.find("in=")+3,loc);
						wgd[id].set_in(atoi(dummy.c_str()));
						dummy.erase();

						//out
						loc=0;
						while(str[str.find("out=")+4+loc]!=';' ) 
							loc++;
						dummy.assign(str,str.find("out=")+4,loc);
						wgd[id].set_out(atoi(dummy.c_str()));
						dummy.erase();

						//terminals
						//in (terminal[1])
						loc=0;
						while(str[str.find("con_in=")+7+loc]!=';') 
							loc++;
						dummy.assign(str,str.find("con_in=")+7,loc);
						elm[id].terminals[1]=atoi(dummy.c_str());
						dummy.erase();

						//out (terminal[2])
						loc=0;
						while(str[str.find("con_out=")+8+loc]!=';') 
							loc++;
						dummy.assign(str,str.find("con_out=")+8,loc);
						elm[id].terminals[2]=atoi(dummy.c_str());
						dummy.erase();
					}
					else if(str.compare(7,3,"CSE")==0) //Crossing BOSE definition
					{
						//id
						while(str[str.find("id=")+3+loc]!=';' )
							loc++;
						dummy.assign(str,str.find("id=")+3,loc);
						id=atoi(dummy.c_str());
						dummy.erase();
						elm[id].id=id;
						elm[id].type=5; //Crossing BOSE is type=5

						//west
						loc=0;
						while(str[str.find("west=")+5+loc]!=';' ) 
							loc++;
						dummy.assign(str,str.find("west=")+5,loc);
						cse[id].set_west(atoi(dummy.c_str()));
						dummy.erase();

						//north
						loc=0;
						while(str[str.find("north=")+6+loc]!=';' ) 
							loc++;
						dummy.assign(str,str.find("north=")+6,loc);
						cse[id].set_north(atoi(dummy.c_str()));
						dummy.erase();

						//east
						loc=0;
						while(str[str.find("east=")+5+loc]!=';' ) 
							loc++;
						dummy.assign(str,str.find("east=")+5,loc);
						cse[id].set_east(atoi(dummy.c_str()));
						dummy.erase();

						//south
						loc=0;
						while(str[str.find("south=")+6+loc]!=';' ) 
							loc++;
						dummy.assign(str,str.find("south=")+6,loc);
						cse[id].set_south(atoi(dummy.c_str()));
						dummy.erase();

						//MR number
						loc=0;
						while(str[str.find("MR=")+3+loc]!=';' ) 
							loc++;
						dummy.assign(str,str.find("MR=")+3,loc);
						cse[id].set_CSE_MR(mr[atoi(dummy.c_str())]);
						cse[id].set_CSE_MR_num(atoi(dummy.c_str()));
						dummy.erase();

						//MR Location
						loc=0;
						while(str[str.find("MR_L=")+5+loc]!=';' ) 
							loc++;
						dummy.assign(str,str.find("MR_L=")+5,loc);
						cse[id].set_CSE_MR_Loc(atoi(dummy.c_str()));
						dummy.erase();

						//terminals
						//west (terminal[1])
						loc=0;
						while(str[str.find("con_w=")+6+loc]!=';') 
							loc++;
						dummy.assign(str,str.find("con_w=")+6,loc);
						elm[id].terminals[1]=atoi(dummy.c_str());
						dummy.erase();

						//north (terminal[2])
						loc=0;
						while(str[str.find("con_n=")+6+loc]!=';') 
							loc++;
						dummy.assign(str,str.find("con_n=")+6,loc);
						elm[id].terminals[2]=atoi(dummy.c_str());
						dummy.erase();

						//east (terminal[3])
						loc=0;
						while(str[str.find("con_e=")+6+loc]!=';') 
							loc++;
						dummy.assign(str,str.find("con_e=")+6,loc);
						elm[id].terminals[3]=atoi(dummy.c_str());
						dummy.erase();

						//south (terminal[4])
						loc=0;
						while(str[str.find("con_s=")+6+loc]!=';') 
							loc++;
						dummy.assign(str,str.find("con_s=")+6,loc);
						elm[id].terminals[4]=atoi(dummy.c_str());
						dummy.erase();
					}
					else if(str.compare(7,3,"PSE")==0) //Parallel BOSE definition
					{
						//id
						while(str[str.find("id=")+3+loc]!=';' )
							loc++;
						dummy.assign(str,str.find("id=")+3,loc);
						id=atoi(dummy.c_str());
						dummy.erase();
						elm[id].id=id;
						elm[id].type=6; //Parallel Switching Element type=6

						//in
						loc=0;
						while(str[str.find("in=")+3+loc]!=';' ) 
							loc++;
						dummy.assign(str,str.find("in=")+3,loc);
						pse[id].set_input(atoi(dummy.c_str()));
						dummy.erase();

						//drop
						loc=0;
						while(str[str.find("drop=")+5+loc]!=';' ) 
							loc++;
						dummy.assign(str,str.find("drop=")+5,loc);
						pse[id].set_drop(atoi(dummy.c_str()));
						dummy.erase();

						//through
						loc=0;
						while(str[str.find("through=")+8+loc]!=';' ) 
							loc++;
						dummy.assign(str,str.find("through=")+8,loc);
						pse[id].set_thorugh(atoi(dummy.c_str()));
						dummy.erase();

						//add
						loc=0;
						while(str[str.find("add=")+4+loc]!=';' ) 
							loc++;
						dummy.assign(str,str.find("add=")+4,loc);
						pse[id].set_add(atoi(dummy.c_str()));
						dummy.erase();

						//MR number
						loc=0;
						while(str[str.find("MR=")+3+loc]!=';' ) 
							loc++;
						dummy.assign(str,str.find("MR=")+3,loc);
						pse[id].set_PSE_MR(mr[atoi(dummy.c_str())]);
						pse[id].set_PSE_MR_num(atoi(dummy.c_str()));
						dummy.erase();

						//terminals
						//input (terminal[1])
						loc=0;
						while(str[str.find("con_in=")+7+loc]!=';') 
							loc++;
						dummy.assign(str,str.find("con_in=")+7,loc);
						elm[id].terminals[1]=atoi(dummy.c_str());
						dummy.erase();

						//drop (terminal[2])
						loc=0;
						while(str[str.find("con_d=")+6+loc]!=';') 
							loc++;
						dummy.assign(str,str.find("con_d=")+6,loc);
						elm[id].terminals[2]=atoi(dummy.c_str());
						dummy.erase();

						//through (terminal[3])
						loc=0;
						while(str[str.find("con_t=")+6+loc]!=';') 
							loc++;
						dummy.assign(str,str.find("con_t=")+6,loc);
						elm[id].terminals[3]=atoi(dummy.c_str());
						dummy.erase();

						//add (terminal[4])
						loc=0;
						while(str[str.find("con_a=")+6+loc]!=';') 
							loc++;
						dummy.assign(str,str.find("con_a=")+6,loc);
						elm[id].terminals[4]=atoi(dummy.c_str());
						dummy.erase();
					}
					else if(str.compare(7,3,"WGD")==0) //Extra Waveguides need to construct the router structure
					{
						//id
						while(str[str.find("id=")+3+loc]!=';' )
							loc++;
						dummy.assign(str,str.find("id=")+3,loc);
						id=atoi(dummy.c_str());
						dummy.erase();
						elm[id].id=id;
						elm[id].type=7; //Waveguide type=7

						//in
						loc=0;
						while(str[str.find("in=")+3+loc]!=';' ) 
							loc++;
						dummy.assign(str,str.find("in=")+3,loc);
						wgd[id].set_in(atoi(dummy.c_str()));
						dummy.erase();

						//out
						loc=0;
						while(str[str.find("out=")+4+loc]!=';' ) 
							loc++;
						dummy.assign(str,str.find("out=")+4,loc);
						wgd[id].set_out(atoi(dummy.c_str()));
						dummy.erase();

						//Length
						loc=0;
						while(str[str.find("length=")+7+loc]!=';' ) 
							loc++;
						dummy.assign(str,str.find("length=")+7,loc);
						wgd[id].set_length(atof(dummy.c_str()));
						dummy.erase();

						//terminals
						//in (terminal[1])
						loc=0;
						while(str[str.find("con_in=")+7+loc]!=';') 
							loc++;
						dummy.assign(str,str.find("con_in=")+7,loc);
						elm[id].terminals[1]=atoi(dummy.c_str());
						dummy.erase();

						//out (terminal[2])
						loc=0;
						while(str[str.find("con_out=")+8+loc]!=';') 
							loc++;
						dummy.assign(str,str.find("con_out=")+8,loc);
						elm[id].terminals[2]=atoi(dummy.c_str());
						dummy.erase();
					}
					else if(str.compare(7,3,"OME")==0) //Optical Modulating Elements
					{
						//id
						while(str[str.find("id=")+3+loc]!=';' )
							loc++;
						dummy.assign(str,str.find("id=")+3,loc);
						id=atoi(dummy.c_str());
						dummy.erase();
						elm[id].id=id;
						elm[id].type=8; //BOME type=8

						//in
						loc=0;
						while(str[str.find("in=")+3+loc]!=';' ) 
							loc++;
						dummy.assign(str,str.find("in=")+3,loc);
						wgd[id].set_in(atoi(dummy.c_str()));
						dummy.erase();

						//out
						loc=0;
						while(str[str.find("out=")+4+loc]!=';' ) 
							loc++;
						dummy.assign(str,str.find("out=")+4,loc);
						wgd[id].set_out(atoi(dummy.c_str()));
						dummy.erase();

						//terminals
						//in (terminal[1])
						loc=0;
						while(str[str.find("con_in=")+7+loc]!=';') 
							loc++;
						dummy.assign(str,str.find("con_in=")+7,loc);
						elm[id].terminals[1]=atoi(dummy.c_str());
						dummy.erase();

						//out (terminal[2])
						loc=0;
						while(str[str.find("con_out=")+8+loc]!=';') 
							loc++;
						dummy.assign(str,str.find("con_out=")+8,loc);
						elm[id].terminals[2]=atoi(dummy.c_str());
						dummy.erase();
					}
				}
			}
		}
	}
	router_struct.close();
	//for(int i=0;i<number_of_ports;i++)
		//cout<<endl<<port[i].get_prev()<<endl<<port[i].get_next();
	//cout<<endl;
	//for(int i=0;i<10;i++)
		//cout<<"\nID:"<<elm[i].id<<endl<<"Type:"<<elm[i].type<<"\n "<<"Teminal"<<elm[i].terminals[0];
	
	//for(int i=0;i<total_number;i++)
		//cout<<"\nID:"<<elm[i].id<<endl<<"Type: "<<elm[i].type<<"\n "<<"Teminal "<<elm[i].terminals[0]<<" "<<elm[i].terminals[1]<<" "<<elm[i].terminals[2]<<" "<<elm[i].terminals[3]<<" "<<elm[i].terminals[4]<<endl;
	//for(int i=0;i<number_of_crossings;i++)
		//cout<<endl<<wc[i].get_west()<<" "<<wc[i].get_north()<<" "<<wc[i].get_east()<<" "<<wc[i].get_south()<<endl;
	//for(int i=0;i<number_of_bendings;i++)
		//cout<<endl<<wb[i].get_in()<<endl<<wb[i].get_out();
	//for(int i=0;i<number_of_CSEs;i++)
		//cout<<cse[i].get_west()<<" "<<cse[i].get_north()<<" "<<cse[i].get_east()<<" "<<cse[i].get_south()<<" "<<cse[i].get_CSE_MR()<<" "<<cse[i].get_CSE_MR_Loc()<<endl;
	//for(int i=0;i<number_of_PSEs;i++)
		//cout<<pse[i].get_id()<<endl<<pse[i].get_input()<<" "<<pse[i].get_drop()<<" "<<pse[i].get_through()<<" "<<pse[i].get_add()<<" "<<pse[i].get_PSE_MR()<<endl;
	//for(int i=0;i<number_of_WGDs;i++)
		//cout<<endl<<wgd[i].get_in()<<endl<<wgd[i].get_out();
	//for(int i=0;i<number_of_ports;i++)
		//cout<<endl<<port_type[i];
	
}
